<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "practice_group".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "PracticeGroup".
 *
 * Columns in table "practice_group" available as properties of the model,
 * followed by relations of table "practice_group" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property integer $tax_id
 * @property integer $core_only
 * @property integer $wisconsin_only
 * @property integer $national_ppo
 * @property integer $mercy
 * @property integer $medical_service
 * @property integer $chiropractic_service
 * @property integer $mental_healther_service
 * @property integer $home_health_service
 * @property integer $oral_surgery_service
 * @property string $npi_group_id
 * @property string $website
 *
 * @property Practice[] $practices
 */
abstract class BasePracticeGroup extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'practice_group';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'PracticeGroup|PracticeGroups', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name, tax_id', 'required'),
            array('tax_id, core_only, wisconsin_only, national_ppo, mercy, medical_service, chiropractic_service, '
                . 'mental_healther_service, home_health_service, oral_surgery_service', 'numerical',
                'integerOnly' => true),
            array('name', 'length', 'max' => 100),
            array('npi_group_id', 'length', 'max' => 10),
            array('website', 'length', 'max' => 255),
            array('core_only, wisconsin_only, national_ppo, mercy, medical_service, chiropractic_service, '
                . 'mental_healther_service, home_health_service, oral_surgery_service, npi_group_id, website',
                'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, tax_id, core_only, wisconsin_only, national_ppo, mercy, medical_service, '
                . 'chiropractic_service, mental_healther_service, home_health_service, oral_surgery_service, '
                . 'npi_group_id, website', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'practices' => array(self::HAS_MANY, 'Practice', 'practice_group_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'tax_id' => Yii::t('app', 'Tax'),
            'core_only' => Yii::t('app', 'Core Only'),
            'wisconsin_only' => Yii::t('app', 'Wisconsin Only'),
            'national_ppo' => Yii::t('app', 'National Ppo'),
            'mercy' => Yii::t('app', 'Mercy'),
            'medical_service' => Yii::t('app', 'Medical Service'),
            'chiropractic_service' => Yii::t('app', 'Chiropractic Service'),
            'mental_healther_service' => Yii::t('app', 'Mental Healther Service'),
            'home_health_service' => Yii::t('app', 'Home Health Service'),
            'oral_surgery_service' => Yii::t('app', 'Oral Surgery Service'),
            'npi_group_id' => Yii::t('app', 'Npi Group'),
            'website' => Yii::t('app', 'Website'),
            'practices' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('tax_id', $this->tax_id);
        $criteria->compare('core_only', $this->core_only);
        $criteria->compare('wisconsin_only', $this->wisconsin_only);
        $criteria->compare('national_ppo', $this->national_ppo);
        $criteria->compare('mercy', $this->mercy);
        $criteria->compare('medical_service', $this->medical_service);
        $criteria->compare('chiropractic_service', $this->chiropractic_service);
        $criteria->compare('mental_healther_service', $this->mental_healther_service);
        $criteria->compare('home_health_service', $this->home_health_service);
        $criteria->compare('oral_surgery_service', $this->oral_surgery_service);
        $criteria->compare('npi_group_id', $this->npi_group_id, true);
        $criteria->compare('website', $this->website, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
